---
updatedAt: 2025-11-13T14:34:31.000Z
agentTools:
  siteIndex: https://docs.affirm.com/llms.txt
  projectIndex: https://docs.affirm.com/developers/v1.0-Global-Integration/llms.txt
---

# Actions

Understand Affirm's Transactions API actions.

![](https://files.readme.io/8cebe7f-Transactions_Actions.png "Transactions Actions.png")

***

## Overview

After creating a `transaction`, you can manage it through various states and integrate each of the actions into your order management system where you fulfill orders and/or process payments, refunds, and cancelations.

***

## Read

With the [Read Transaction](https://docs.affirm.com/developers/v1.0-Global-Integration/reference/read_transaction) API, you can use the `id` returned from the `transaction` object to retrieve all checkout data and the transaction status for a specific transaction. Reading transaction information is useful for updating your records or order management system with the current state of a transaction before performing any actions on it. It can also keep your system in sync with Affirm if your staff is manually managing loans in the merchant dashboard.

You can read single or multiple transactions. If you don't specify an `id`, the response includes a list of transactions. You can define how the results are paginated using the `limit`, `before`, and `after` query parameters.

```curl
// Read a single transaction
curl https://api.global.sandbox.affirm.com/api/v1/transactions/id
     -X GET
     -u "public_key:private_key"
 
// Read multiple transactions
curl https://api.global.sandbox.affirm.com/api/v1/transactions/?limit=5&before=1234-ABCD
     -X GET
     -u "public_key:private_key"
```

***

## Void

To cancel or delete an authorized transaction, use the `id` associated with the transaction to void it. For example, this can occur when a user decides to cancel their order before it's fulfilled. We can only void uncaptured loans.

Voiding an authorized transaction does the following:

* Permanently cancels a loan.
* Notifies the user that the transaction was canceled.

```curl
curl https://api.global.sandbox.affirm.com/api/v1/transactions/id/void
     -X POST
     -u "(public_api_key):(private_api_key)"
```

***

## Refund

You can refund a transaction based on the original purchase, similar to refunding a credit card transaction. Affirm automatically calculates all interest and fees corresponding to the refunded amount.

You can also specify an amount to refund part of a transaction. For partial refunds, you can apply any amount of refunds as long as there is a positive balance on the loan.

Once a loan has been fully refunded, it can’t be reinstated. You can refund the customer using the [Refund Transaction](https://docs.affirm.com/developers/v1.0-Global-Integration/reference/refund_transaction) request or the [Merchant Portal](https://docs.affirm.com/developers/v1.0-Global-Integration/docs/dashboard).

```curl
curl https://api.global.sandbox.affirm.com/api/v1/transactions/id/refund
     -X POST
     -u "(public_api_key):(private_api_key)"
     -H "Content-Type: application/json"
     -d '{"amount": 50000}'
```

***

## Update

Use the [Update Transaction](https://docs.affirm.com/developers/v1.0-Global-Integration/reference/update_transaction) request to update a transaction with new fulfillment or order information, such as `shipping_confirmation`, `shipping_carrier`, or `order_id`. Settlement reports associate your internal order IDs with specific Affirm transactions.

```curl
curl https://api.global.sandbox.affirm.com/api/v1/transactions/id/update
     -X POST
     -u "(public_api_key):(private_api_key)"
     -H "Content-Type: application/json"
     -H "country-code: CAN"
     -d '{"order_id": "JLKM4321", "shipping_carrier": "USPS", "shipping_confirmation": "1Z23223", "shipping": {"name":{ "full": "John Doe"},"address": {"line1": "325 Pacific Ave", "state": "CA", "city": "San Francisco", "zipcode": "94111", "country": "USA"}}}'
```

# Sibling pages

* [Authorize and Capture Transactions](https://docs.affirm.com/developers/v1.0-Global-Integration/docs/authorize-and-capture-transactions.md)
* [Transaction States](https://docs.affirm.com/developers/v1.0-Global-Integration/docs/transaction-states.md)